unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, opengl, glut, glaux;

type
  TForm1 = class(TForm)
  Panel1: TPanel;
  Timer1: TTimer;
  procedure SetDCPixelFormat(Handle: HDC);
  procedure initopengl(where: TPanel);
  procedure initexturas;
  procedure RenderGLScene;
  procedure Panel1Click(Sender: TObject);
  procedure Render2;
    procedure Timer1Timer(Sender: TObject);

  private
    { Private declarations }
    ogl_contex: HGLRC;
    ogl_win: Thandle;
    ogl_paper: HDC;
  public
    { Public declarations }
    rotacion: integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure TForm1.SetDCPixelFormat(Handle: HDC);

var
   pfd: TPixelFormatDescriptor;
   nPixelFormat: Integer;
begin

   FillChar(pfd, SizeOf(pfd), 0);
   with pfd do
   begin
      nSize := sizeof(pfd);
      nVersion := 1;
      dwFlags := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
      iPixelType := PFD_TYPE_RGBA;
      cColorBits := 24;
      cDepthBits := 32;
      iLayerType := PFD_MAIN_PLANE;
      nPixelFormat := ChoosePixelFormat(Handle, @pfd);
      SetPixelFormat(Handle, nPixelFormat, @pfd);
   end;
end;
{Damos valores a las var del formulario}

procedure TForm1.initopengl(where: TPanel);
begin
   ogl_win := where.handle;
   ogl_paper:= GetDC(where.handle);
   SetDCPixelFormat(ogl_paper);
   ogl_contex := wglCreateContext(ogl_paper);
   wglMakeCurrent(ogl_paper, ogl_contex);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glulookat(50, 0, 0, 0, 0, 0, 0, 1, 0);
   glMatrixMode(GL_PROJECTION);
   gluPerspective(45, where.width/where.height, 1, 100);
   glEnable(GL_TEXTURE_2D);
   rotacion := 0;
end;

procedure TForm1.RenderGLScene;
begin
   glClearColor(1.0, 0.0, 0.0, 1.0);
   glClear(GL_COLOR_BUFFER_BIT);
   Render2;
end;
procedure TForm1.Panel1Click(Sender: TObject);
begin
    initOpengl(Panel1);
    RenderGLScene;
    SwapBuffers(ogl_paper)
end;

procedure TForm1.Render2;
var esfera: GLuquadricObj;
begin
   initexturas;
   esfera := gluNewquadric();
   gluQuadricDrawStyle(esfera, GLU_FILL);
   gluQuadricOrientation(esfera, GLU_OUTSIDE);
   gluQuadricNormals(esfera, GLU_SMOOTH);
   gluQuadricTexture(esfera, GL_TRUE);
   gluSphere(esfera, 5, 20, 20);
end;
procedure TForm1.initexturas;
var tex_fich: PTAUX_RGBImageRec;
begin
   tex_fich := auxDIBImageLoadA('.\tierra.bmp'); //Cargamos la imagen que utilizaremos como textura
   {glTexparamenter especifica como debe ser tratada la textura, como se debe pegar
   qu hacer si el txel no coincide con el pxel magnificacin o minimizacin,
   los bordes, y otros}
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
 	 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
   glTexImage2D(GL_TEXTURE_2D, //Cargamos una textura 2D, tambin puede ser 1D, 3D
               0,    //Slo vamos a utilizar una textura, se pone 0.
               3,    //Nmero de componentes de color para describir un txel.
                     //si es uno es indexado, y si es 3 es RGB, si es 4 es RGBA
               tex_fich^.sizeX,  //Ancho de la textura, debe ser mltiplo de 2.
               tex_fich^.sizeY,  //Alto de la textura, debe ser mltiplo de 2.
               0,               //Ancho del borde
               GL_RGB,          //Formato de la informacin del pxel.
               GL_UNSIGNED_BYTE, //Tipo de dato de cada pxel
               tex_fich^.data);  //Puntero al bitmap.
   end;
procedure TForm1.Timer1Timer(Sender: TObject);

begin
  rotacion := 15 + rotacion;
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  glRotate(rotacion mod 360, 0, 1, 0);
  glTranslate(50, 0, 0);
  RenderGLScene;
  SwapBuffers(ogl_paper);
end;

end.
